DECLARE SUB outputset (n%)
DECLARE SUB fontrealcolupdate (n%)
DECLARE SUB pageredraw ()
DECLARE SUB wndrefreshtagb (tag%)
DECLARE FUNCTION rgb2long& (R%, G%, B%)
DECLARE SUB insertint (v%, value%, vpos%, range%)
DECLARE SUB int2bytes (v%, V1%, V2%)
DECLARE SUB long2rgb (v&, R%, G%, B%)
DECLARE FUNCTION charlenget% (lenmasknum%, charnum%)
DECLARE FUNCTION filerip$ (filename$)
DECLARE SUB fontrealcolset (fontnum%, realcol&)
DECLARE FUNCTION imginrowget% (n%)
DECLARE FUNCTION inputint% ()
DECLARE FUNCTION inputstr$ ()
DECLARE FUNCTION max% (V1%, V2%)
DECLARE FUNCTION min% (V1%, V2%)
DECLARE FUNCTION oneormore% (v%)
DECLARE FUNCTION oneormores! (v!)
DECLARE FUNCTION pathrip$ (filename$)
DECLARE FUNCTION sts$ (v!)
DECLARE FUNCTION symget% ()

REM $DYNAMIC
DEFINT A-Z
SUB bounds2set (s1, s2, t1, t2, vmin, vmax)
IF s1 < vmin THEN t1 = vmin ELSE t1 = s1
IF s2 > vmax THEN t2 = vmax ELSE t2 = s2
END SUB

SUB boxcoordsset (boxnum, X, y, xsiz, ysiz)
IF X >= 0 THEN box(boxnum).X = X
IF y >= 0 THEN box(boxnum).y = y
IF xsiz >= 0 THEN box(boxnum).xsiz = xsiz
IF ysiz >= 0 THEN box(boxnum).ysiz = ysiz
END SUB

SUB boxformatset (boxnum, Mode, halign, valign, toframe, fontnum)
m = box(boxnum).format
insertint m, Mode, 1, 16
insertint m, halign, 16, 3
insertint m, valign, 48, 3
insertint m, toframe, 144, 2
insertint m, fontnum, 288, -1
box(boxnum).format = m
END SUB

SUB boxframeget (boxnum, framn, framsn)
framn = box(boxnum).framn
framsn = box(boxnum).framsn
END SUB

SUB boxframeset (boxnum, framn, framsn)
box(boxnum).framn = framn
box(boxnum).framsn = bounds(framsn, 0, framsn)
END SUB

SUB boxhelpset (boxnum, msgnum)
box(boxnum).help = msgnum
END SUB

SUB boxlabelget (boxnum, n, sn)
n = box(boxnum).msg
sn = box(boxnum).imgsn
END SUB

SUB boxlabelset (boxnum, n, sn)
IF n >= 0 THEN box(boxnum).msg = n
IF sn >= 0 THEN box(boxnum).imgsn = sn
END SUB

FUNCTION charlenget (lenmasknum, charnum)
charlenget = ASC(MID$(lenmask(lenmasknum), charnum, 1))
END FUNCTION

FUNCTION filerip$ (filename$)
FOR n = LEN(filename$) TO 1 STEP -1
 IF MID$(filename$, n, 1) = "\" THEN
  filerip$ = MID$(filename$, n + 1)
  EXIT FUNCTION
 END IF
NEXT n
filerip$ = filename$
END FUNCTION

SUB fontcolorget (fontnum, R, G, B)
long2rgb font(fontnum).col, R, G, B
END SUB

SUB fontcolorset (fontnum, R, G, B)
rgb2long font(fontnum).col, R, G, B
IF sbytes = 1 THEN fontrealcolset curfont, colfind(R, G, B)
END SUB

SUB fontcopy (fromfont, tofont)
font(tofont) = font(fromfont)
END SUB

SUB fontfileitemsset (filenum, xsiz, ysiz, inrow, qua)
fontfile(filenum).siz = bytes2int(xsiz, ysiz)
fontfile(filenum).qua = bytes2int(inrow - 1, qua - 1)
END SUB

SUB fontformatset (fontnum, typ, lenmasknum, layers)
f = font(fontnum).typ
insertint f, typ, 1, 64
insertint f, layers - 1, 64, 8
insertint f, lenmasknum, 1024, -1
font(fontnum).typ = f
END SUB

SUB fontrealcolset (fontnum, realcol&)
font(fontnum).realcol = realcol&
fontrealcolupdate fontnum
END SUB

SUB fontshiftget (fontnum, xshift, yshift)
int2bytes font(fontnum).shift, xshift, yshift
END SUB

SUB fontshiftset (fontnum, xshift, yshift)
font(fontnum).shift = bytes2int(xshift, yshift)
END SUB

SUB fontsizeset (fontnum, xsiz, ysiz)
font(fontnum).siz = bytes2int(xsiz, ysiz)
END SUB

SUB fontspacingget (fontnum, hspnorm, hspmin)
int2bytes font(fontnum).hsp, hspmin, hspnorm
hspmin = hspmin - 128
hspnorm = hspnorm - 128
END SUB

SUB fontspacingset (fontnum, hspnorm, hspmin)
font(fontnum).hsp = bytes2int(hspmin + 128, hspnorm + 128)
END SUB

SUB fontsymget (fontnum, fcursor$, fdots$)
fcursor$ = font(fontnum).cursor
fdots$ = font(fontnum).dots
END SUB

SUB fontsymset (fontnum, fcursor$, fdots$)
IF fcursor$ <> "" THEN font(fontnum).cursor = fcursor$
IF fdots$ <> "" THEN font(fontnum).dots = fdots$
END SUB

SUB imgcoordsgetb (n, X1, Y1, X2, Y2)
X1 = img(n).X
Y1 = img(n).y
X2 = img(n).xsiz + X1 - 1
Y2 = img(n).ysiz + Y1 - 1
END SUB

SUB imgcoordsset (n, X, y, xsiz, ysiz)
img(n).X = X
img(n).y = y
img(n).xsiz = xsiz
img(n).ysiz = ysiz
END SUB

SUB imgcopy (fromimg, toimg)
img(toimg) = img(fromimg)
END SUB

SUB imgformatset (n, typ, style, saf)
int2bytes img(n).format, m, m2
insertint m, typ, 1, 3
insertint m, saf, 3, 3
insertint m, style, 9, -1
img(n).format = bytes2int(m, m2)
END SUB

FUNCTION imginrowget (n)
int2bytes img(n).format, 0, v
imginrowget = v
END FUNCTION

SUB imginrowset (n, ir)
int2bytes img(n).format, v, 0
img(n).format = bytes2int(v, ir)
END SUB

FUNCTION inputint
INPUT #1, v$
v = INSTR(v$, "=")
IF v > 0 THEN inputint = VAL(MID$(v$, v + 1))
END FUNCTION

FUNCTION inputstr$
INPUT #1, v$
V1 = INSTR(v$, CHR$(34))
V2 = INSTR(V1 + 1, v$, CHR$(34))
IF V2 > 0 THEN inputstr$ = MID$(v$, V1 + 1, V2 - V1 - 1)
END FUNCTION

SUB lenmaskedit (lenmasknum, maskpos, symsize, symq)
MID$(lenmask$(lenmasknum), maskpos, symq) = STRING$(symq, symsize)
wndrefreshtagb 7
END SUB

SUB lenmaskreset (lenmasknum, xsiz)
lenmask$(lenmasknum) = STRING$(224, xsiz)
END SUB

FUNCTION max (V1, V2)
IF V1 > V2 THEN max = V1 ELSE max = V2
END FUNCTION

FUNCTION min (V1, V2)
IF V1 < V2 THEN min = V1 ELSE min = V2
END FUNCTION

FUNCTION oneormore (v)
IF v < 1 THEN oneormore = 1 ELSE oneormore = v
END FUNCTION

FUNCTION oneormores! (v!)
IF v! < 1 THEN oneormores! = 1 ELSE oneormores! = v!
END FUNCTION

SUB paladapt
IF sbytes > 1 THEN EXIT SUB
setpage 0
FOR n = 0 TO 63
 newpal$ = newpal$ + CHR$(colfind(n * 4, n * 4, n * 4))
NEXT n
SetEMSpage 2
FOR X = 0 TO 639
 FOR y = 0 TO 479
  v = Future.POINT(X, y)
  IF v = curskinmask& THEN
   ov = 64
  ELSEIF v >= 0 AND v <= 63 THEN
   ov = ASC(MID$(newpal$, v + 1, 1))
  END IF
   Future.PSET X, y, ov
NEXT y, X
curskinmask& = 64
outputset 0
pageredraw
END SUB

FUNCTION pathrip$ (filename$)
FOR n = LEN(filename$) TO 1 STEP -1
 IF MID$(filename$, n, 1) = "\" THEN
  pathrip$ = LEFT$(filename$, n)
  EXIT FUNCTION
 END IF
NEXT n
END FUNCTION

SUB shiftbounds (v!, vmin!, vmax!)
IF vmin! < v! THEN vmin! = v!
IF vmax! > v! THEN vmax! = v!
END SUB

SUB shiftersget (rshift, lshift, ctrl, alt)
DEF SEG = 0
 C = PEEK(&H417)
DEF SEG
rshift = C AND 1
lshift = C AND 2
ctrl = C AND 4
alt = C AND 8
END SUB

FUNCTION sts$ (v!)
sts$ = LTRIM$(STR$(v!))
END FUNCTION

FUNCTION symget
a$ = " "
GET #1, , a$
symget = ASC(a$)
END FUNCTION

SUB symmaskedit (symmsk, maskpos, fromsym, tosym)
IF fromsym <= 0 THEN EXIT SUB
nn = maskpos
FOR n = fromsym TO tosym
 MID$(symmask$(symmsk), nn, 1) = CHR$(n - 1)
 nn = nn + 1
 IF nn > 224 THEN EXIT FOR
NEXT n
wndrefreshtagb 7
END SUB

SUB symmaskreset (symmasknum)
FOR n = 1 TO 224
 MID$(symmask$(symmasknum), n, 1) = CHR$(n + 31)
NEXT n
END SUB

SUB symput (v)
a$ = CHR$(v)
PUT #1, , a$
END SUB

SUB wndcopy (fromwnd, townd)
wnd(townd) = wnd(fromwnd)
END SUB

SUB wndmgnboundsget (tag, xmgnmin!, xmgnmax!, ymgnmin!, ymgnmax!)
xmgnmin! = wnd(tag).xmgnmin
xmgnmax! = wnd(tag).xmgnmax
ymgnmin! = wnd(tag).ymgnmin
ymgnmax! = wnd(tag).ymgnmax
END SUB

